<template>
	<div class="flex w-full flex-col">
		<div class="flex justify-between w-full mb-6 pl-2 md:pl-4">
			<h2>Your cart</h2>
			<div
				v-if="CART_STATE != 'Merged'"
				class="inline-flex flex-wrap items-center justify-center mb-3 space-x-4 text-sm text-gray-500 lg:flex font-primary-font-bold"
			>
				<button aria-label="Close" @click="toggleOff" @keypress.enter="toggleOff">
					<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 12 11" class="w-3.5 h-3.5 fill-current">
						<g fill="none" fill-rule="evenodd">
							<g fill="#000">
								<g>
									<g>
										<g>
											<path
												d="M10.125 3.25c.552 0 1 .448 1 1l-.001 4.624 4.626.001c.552 0 1 .448 1 1v.25c0 .552-.448 1-1 1l-4.626-.001.001 4.626c0 .552-.448 1-1 1h-.25c-.552 0-1-.448-1-1l-.001-4.626-4.624.001c-.552 0-1-.448-1-1v-.25c0-.552.448-1 1-1l4.624-.001.001-4.624c0-.552.448-1 1-1h.25z"
												transform="translate(-345 -363) translate(15 268) translate(92 89.554) translate(234 .661) rotate(45 10 10)"
											></path>
										</g>
									</g>
								</g>
							</g>
						</g>
					</svg>
				</button>
			</div>
		</div>
		<p
			v-show="cartHeading && !PROMOTION_MESSAGE"
			class="text-xl md:text-2xl mb-8 pl-2 md:pl-4 font-secondary-font-regular"
		>
			The clean air you deserve.
		</p>
		<div v-show="isCartDiscountProduct">
			<MkStepsSuccess v-if="PROMOTION_MESSAGE" :process-step="processStep" :total-step="totalStep" />
			<p class="mt-6 mb-8 px-2 md:px-4 font-secondary-font-regular text-lg">
				{{ PROMOTION_MESSAGE }}
			</p>
		</div>
		<div v-for="lineItem in LINE_ITEMS" :key="lineItem.id">
			<MkCartCard :item="lineItem" />
		</div>
		<MkWhatPair v-show="isPairDiscountProduct" :product-details="productDetails" />
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkStepsSuccess from '~/components/D2C/atoms/MkStepsSuccess.vue';
import MkCartCard from '~/components/D2C/molecules/MkCartCard.vue';
import MkWhatPair from '~/components/D2C/molecules/MkWhatPair.vue';
export default {
	name: 'MkCartHeader',
	components: {
		MkStepsSuccess,
		MkCartCard,
		MkWhatPair,
	},
	props: {},
	data() {
		return {
			processStep: 0,
			productDetails: {},
			isPairDiscountProduct: false,
			isCartDiscountProduct: false,
			cartHeading: true,
			totalStep: 2,
		};
	},
	computed: {
		...mapState(['apiLocale']),
		...mapState('CART_STORE', ['LINE_ITEMS', 'PROMOTION_MESSAGE', 'PROMOTION_PRODUCT', 'CART_STATE']),
	},
	watch: {
		// close the cart when delete the last item
		LINE_ITEMS(newValue, oldvalue) {
			if (!this.LINE_ITEMS.length) {
				this.toggleOff();
			}
			const lineItemCount = this.LINE_ITEMS.length;
			if (lineItemCount === 0) {
				return null;
			}
			if (this.PROMOTION_MESSAGE !== ' ') {
				if (Object.keys(this.PROMOTION_PRODUCT).length !== 0) {
					this.isPairDiscountProduct = true;
					this.isCartDiscountProduct = false;
				} else {
					this.isCartDiscountProduct = true;
					this.isPairDiscountProduct = false;
				}
			} else {
				this.isPairDiscountProduct = false;
				this.isCartDiscountProduct = false;
			}
			if (this.PROMOTION_MESSAGE !== ' ' && (this.isPairDiscountProduct || this.isCartDiscountProduct)) {
				this.productDetails.promotionMessage = this.PROMOTION_MESSAGE;
				if (this.isPairDiscountProduct === true) {
					this.productDetails.productId = this.PROMOTION_PRODUCT.id;
					if (this.PROMOTION_PRODUCT && this.PROMOTION_PRODUCT.obj) {
						const item = this.PROMOTION_PRODUCT.obj.masterData;
						this.productDetails.productName = item.current.name ? item.current.name[this.apiLocale] : 'Product Name';
						this.productDetails.productSku = item.current.masterVariant.sku;
					}
				}
				if (this.isCartDiscountProduct) {
					if (this.PROMOTION_MESSAGE) {
						let sortOrder = 0;
						let lineItemquantity = 0;
						this.LINE_ITEMS.forEach((element) => {
							if (element.discountedPricePerQuantity.length > 0) {
								const { discountedPrice, quantity } = element.discountedPricePerQuantity[0];
								const { includedDiscounts } = discountedPrice;
								let discount = {};
								if (includedDiscounts[0]?.discount) {
									discount = includedDiscounts[0].discount;
								}
								if (discount?.obj) {
									if (sortOrder < discount.obj.sortOrder) {
										sortOrder = discount.obj.sortOrder;
										lineItemquantity = quantity;
									}
								}
							}
						});
						if (lineItemquantity === 1) {
							this.processStep = 1;
						} else if (lineItemquantity === 2) {
							this.processStep = 2;
						} else {
							this.processStep = 0;
						}
					}
				}
			}
		},
	},
	mounted() {},
	methods: {
		toggleOff() {
			this.$store.dispatch('MK_CART_STORE/TOGGLE_SIDE_CART', 'HIDE');
		},
	},
};
</script>
